Authorize 10.0.1.2 for one of the BSD test-farm systems.
[rsync/rsync.git] / testsuite / rsync.fns
CommitLineData
d820215b
MP
1#! /bin/sh
2
3# Copyright (C) 2001 by Martin Pool <mbp@samba.org>
4
5# General-purpose test functions for rsync.
3a4c683f 6
0154b302
MP
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License version
9# 2 as published by the Free Software Foundation.
10#
11# This program is distributed in the hope that it will be useful, but
12# WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
14# Lesser General Public License for more details.
15#
16# You should have received a copy of the GNU Lesser General Public
17# License along with this program; if not, write to the Free Software
18# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
19
20
6f481bb0 21tmpdir="$scratchdir"
e3442095
WD
22fromdir="$tmpdir/from"
23todir="$tmpdir/to"
24chkdir="$tmpdir/chk"
3a4c683f 25
2094283b 26# Berkley's nice.
96553aa7 27PATH="$PATH:/usr/ucb"
2094283b 28
e3442095 29if diff -u "$srcdir/testsuite/rsync.fns" "$srcdir/testsuite/rsync.fns" >/dev/null 2>&1; then
84229c7a
WD
30 diffopt="-u"
31else
32 diffopt="-c"
33fi
34
a98cad00
WD
35HOME="$scratchdir"
36export HOME
37
3a4c683f
MP
38runtest() {
39 echo $ECHO_N "Test $1: $ECHO_C"
501972bf
MP
40 if eval "$2"
41 then
6f481bb0 42 echo "$ECHO_T done."
501972bf
MP
43 return 0
44 else
6f481bb0 45 echo "$ECHO_T failed!"
501972bf
MP
46 return 1
47 fi
3a4c683f
MP
48}
49
757287d8
WD
50# Call this if you want to filter out verbose messages (-v or -vv) from
51# the output of an rsync run (whittling the output down to just the file
52# messages). This isn't needed if you use -i without -v.
53filter_outfile() {
54 sed -e '/^building file list /d' \
55 -e '/^created directory /d' \
56 -e '/^done$/d' \
57 -e '/ --whole-file$/d' \
58 -e '/^total: /d' \
332cf6df
WD
59 -e '/^client charset: /d' \
60 -e '/^server charset: /d' \
757287d8
WD
61 -e '/^$/,$d' \
62 <"$outfile" >"$outfile.new"
63 mv "$outfile.new" "$outfile"
64}
65
3a4c683f
MP
66printmsg() {
67 echo "$1"
68}
69
6773a779 70rsync_ls_lR() {
db9c9e27 71 find "$@" -print | sort | sed 's/ /\\ /g' | xargs "$TOOLDIR/tls" $TLS_ARGS
dfef3f10
MP
72}
73
18d7e9f4 74check_perms() {
eace352b
WD
75 perms=`"$TOOLDIR/tls" "$1" | sed 's/^[-d]\(.........\).*/\1/'`
76 if test $perms = $2; then
77 return 0
78 fi
79 echo "permissions: $perms on $1"
80 echo "should be: $2"
81 test_fail "failed test $3"
18d7e9f4
WD
82}
83
dfef3f10
MP
84rsync_getgroups() {
85 "$TOOLDIR/getgroups"
57835c00
MP
86}
87
88
e052b21f 89####################
6f481bb0 90# Build test directories $todir and $fromdir, with $fromdir full of files.
e052b21f 91
3a4c683f 92hands_setup() {
501972bf 93 # Clean before creation
6f481bb0
WD
94 rm -rf "$fromdir"
95 rm -rf "$todir"
3d807132 96
e3442095
WD
97 [ -d "$tmpdir" ] || mkdir "$tmpdir"
98 [ -d "$fromdir" ] || mkdir "$fromdir"
99 [ -d "$todir" ] || mkdir "$todir"
3a4c683f 100
e052b21f
MP
101 # On some BSD systems, the umask affects the mode of created
102 # symlinks, even though the mode apparently has no effect on how
103 # the links behave in the future, and it cannot be changed using
104 # chmod! rsync always sets its umask to 000 so that it can
105 # accurately recreate permissions, but this script is probably run
106 # with a different umask.
107
108 # This causes a little problem that "ls -l" of the two will not be
109 # the same. So, we need to set our umask before doing any creations.
110
3a4c683f 111 # set up test data
6f481bb0
WD
112 touch "$fromdir/empty"
113 mkdir "$fromdir/emptydir"
e8ca5901 114
571a4b26 115 # a hundred lines of text or so
6f481bb0 116 rsync_ls_lR "$srcdir" > "$fromdir/filelist"
3a4c683f 117
6f481bb0 118 echo $ECHO_N "This file has no trailing lf$ECHO_C" > "$fromdir/nolf"
0154b302 119 umask 0
6f481bb0 120 ln -s nolf "$fromdir/nolf-symlink"
4c80c473 121 umask 022
0154b302 122
db10766a 123 cat "$srcdir"/*.c > "$fromdir/text"
6f481bb0
WD
124 mkdir "$fromdir/dir"
125 cp "$fromdir/text" "$fromdir/dir"
126 mkdir "$fromdir/dir/subdir"
127 echo some data > "$fromdir/dir/subdir/foobar.baz"
128 mkdir "$fromdir/dir/subdir/subsubdir"
a7a1cc2c
WD
129 if [ -r /etc ]; then
130 ls -ltr /etc > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
131 else
132 ls -ltr / > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
133 fi
6f481bb0 134 mkdir "$fromdir/dir/subdir/subsubdir2"
a7a1cc2c
WD
135 if [ -r /bin ]; then
136 ls -lt /bin > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
137 else
138 ls -lt / > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
139 fi
7d691654 140
8f98c608 141# echo testing head:
6f481bb0 142# ls -lR "$srcdir" | head -10 || echo failed
3a4c683f 143}
3fedd74b
MP
144
145
99cdaff7
MP
146####################
147# Many machines do not have "mkdir -p", so we have to build up long paths.
148# How boring.
5ef8c5c6 149makepath() {
d1798a2f
WD
150 for p in "${@}"; do
151 (echo " makepath $p"
152
99cdaff7
MP
153 # Absolut Unix.
154 if echo $p | grep '^/' >/dev/null
155 then
156 cd /
157 fi
158
d1798a2f 159 # This will break if $p contains a space.
99cdaff7
MP
160 for c in `echo $p | tr '/' ' '`
161 do
112e7311
MP
162 if [ -d "$c" ] || mkdir "$c"
163 then
164 cd "$c" || return $?
165 else
166 echo "failed to create $c" >&2; return $?
167 fi
d1798a2f
WD
168 done)
169 done
99cdaff7
MP
170}
171
172
173
3fedd74b
MP
174###########################
175# Run a test (in '$1') then compare directories $2 and $3 to see if
176# there are any difference. If there are, explain them.
177
f494f286
MP
178# So normally basically $1 should be an rsync command, and $2 and $3
179# the source and destination directories. This is only good when you
180# expect to transfer the whole directory exactly as is. If some files
181# should be excluded, you might need to use something else.
182
3fedd74b 183checkit() {
3fedd74b 184 failed=
3fedd74b 185
cf72f204
MP
186 # We can just write everything to stdout/stderr, because the
187 # wrapper hides it unless there is a problem.
188
189 echo "Running: \"$1\""
190 eval "$1"
3fedd74b
MP
191 status=$?
192 if [ $status != 0 ]; then
193 failed="YES";
194 fi
195
cf72f204
MP
196 echo "-------------"
197 echo "check how the directory listings compare with diff:"
198 echo ""
6f481bb0
WD
199 ( cd "$2" && rsync_ls_lR . ) > "$tmpdir/ls-from"
200 ( cd "$3" && rsync_ls_lR . ) > "$tmpdir/ls-to"
201 diff $diffopt "$tmpdir/ls-from" "$tmpdir/ls-to" || failed=YES
30688bf1
WD
202
203 echo "-------------"
204 echo "check how the files compare with diff:"
205 echo ""
206 if [ "x$4" != x ]; then
207 echo " === Skipping (as directed) ==="
208 else
209 diff -r $diffopt "$2" "$3" || failed=YES
210 fi
211
212 echo "-------------"
6f481bb0 213 if [ -z "$failed" ] ; then
3fedd74b
MP
214 return 0
215 else
3fedd74b
MP
216 return 1
217 fi
218}
219
863dff51 220
4a7cb3e8 221build_rsyncd_conf() {
d2094cc3
MP
222 # Build an appropriate configuration file
223 conf="$scratchdir/test-rsyncd.conf"
224 echo "building configuration $conf"
225
226 port=2612
227 pidfile="$scratchdir/rsyncd.pid"
228 logfile="$scratchdir/rsyncd.log"
e5255195 229 hostname=`uname -n`
d2094cc3 230
6f481bb0 231 cat >"$conf" <<EOF
3aae15ec 232# rsyncd configuration file autogenerated by $0
d2094cc3 233
3aae15ec
MP
234pid file = $pidfile
235use chroot = no
0eb05245 236hosts allow = localhost 127.0.0.1 10.0.1.2 $hostname
3aae15ec 237log file = $logfile
2ae4126a
WD
238log format = %i %h [%a] %m (%u) %l %f%L
239transfer logging = yes
6f481bb0 240exclude = foobar.baz
eddeaf76 241max verbosity = 9
76ee1d18
WD
242uid = 0
243gid = 0
98c1b325 244
2e6c7f45 245[test-from]
6f481bb0 246 path = $fromdir
3aae15ec 247 read only = yes
d2094cc3 248
2e6c7f45 249[test-to]
6f481bb0 250 path = $todir
3aae15ec 251 read only = no
2ae4126a
WD
252
253[test-scratch]
254 path = $scratchdir
255 read only = no
d2094cc3
MP
256EOF
257}
258
259
3cd2af41 260build_symlinks() {
3cd2af41
MP
261 mkdir "$fromdir"
262 date >"$fromdir/referent"
263 ln -s referent "$fromdir/relative"
264 ln -s "$fromdir/referent" "$fromdir/absolute"
265 ln -s nonexistent "$fromdir/dangling"
1db8b61d 266 ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
3cd2af41
MP
267}
268
269test_fail() {
270 echo "$@" >&2
271 exit 1
272}
273
a217ad30
MP
274test_skipped() {
275 echo "$@" >&2
6f481bb0 276 echo "$@" > "$tmpdir/whyskipped"
a217ad30
MP
277 exit 77
278}
279
be2f866b
MP
280# It failed, but we expected that. don't dump out error logs,
281# because most users won't want to see them. But do leave
282# the working directory around.
283test_xfail() {
284 echo "$@" >&2
285 exit 78
286}
287
d1239eae
MP
288# Determine what shell command will appropriately test for links.
289ln -s foo "$scratchdir/testlink"
290for cmd in test /bin/test /usr/bin/test /usr/ucb/bin/test /usr/ucb/test
291do
292 for switch in -h -L
293 do
294 if $cmd $switch "$scratchdir/testlink" 2>/dev/null
295 then
296 # how nice
297 TEST_SYMLINK_CMD="$cmd $switch"
298 # i wonder if break 2 is portable?
299 break 2
300 fi
301 done
302done
cca4e067
MP
303# ok, now get rid of it
304rm "$scratchdir/testlink"
d1239eae
MP
305
306
307if [ "x$TEST_SYMLINK_CMD" = 'x' ]
308then
309 test_fail "Couldn't determine how to test for symlinks"
310else
311 echo "Testing for symlinks using '$TEST_SYMLINK_CMD'"
312fi
313
314
d96d3893
MP
315# Test whether something is a link, allowing for shell peculiarities
316is_a_link() {
d1239eae
MP
317 # note the variable contains the first option and therefore is not quoted
318 $TEST_SYMLINK_CMD "$1"
d96d3893
MP
319}
320
77867907
MP
321
322# We need to set the umask to be reproducible. Note also that when we
323# do some daemon tests as root, we will setuid() and therefore the
324# directory has to be writable by the nobody user in some cases. The
325# best thing is probably to explicitly chmod those directories after
326# creation.
327
ad301e48 328umask 022